"use strict";

Object.defineProperty(exports, "__esModule", {
  value: true
});
exports["default"] = void 0;

var _ComponentTpl = _interopRequireDefault(require("./templates/ComponentTpl"));

var _HookTpl = _interopRequireDefault(require("./templates/HookTpl"));

var _RTKStoreTpl = _interopRequireDefault(require("./templates/RTKStoreTpl"));

var _RTKSliceTpl = _interopRequireDefault(require("./templates/RTKSliceTpl"));

var _TemplateGenerator = _interopRequireDefault(require("./TemplateGenerator"));

var _SupportFunctions = _interopRequireDefault(require("./support/SupportFunctions"));

function _interopRequireDefault(obj) { return obj && obj.__esModule ? obj : { "default": obj }; }

function _classCallCheck(instance, Constructor) { if (!(instance instanceof Constructor)) { throw new TypeError("Cannot call a class as a function"); } }

function _defineProperties(target, props) { for (var i = 0; i < props.length; i++) { var descriptor = props[i]; descriptor.enumerable = descriptor.enumerable || false; descriptor.configurable = true; if ("value" in descriptor) descriptor.writable = true; Object.defineProperty(target, descriptor.key, descriptor); } }

function _createClass(Constructor, protoProps, staticProps) { if (protoProps) _defineProperties(Constructor.prototype, protoProps); if (staticProps) _defineProperties(Constructor, staticProps); Object.defineProperty(Constructor, "prototype", { writable: false }); return Constructor; }

/**
 * TemplateFactory
 */
var TemplateFactory = /*#__PURE__*/function () {
  function TemplateFactory() {
    _classCallCheck(this, TemplateFactory);
  }

  _createClass(TemplateFactory, null, [{
    key: "createTemplateFor",
    value:
    /**
     * Factory to generate the templates
     * @param cli options
     */
    function createTemplateFor(cli) {
      /**
       * Generate React tsx component
       */
      if (cli.component) {
        var seperatePath = _SupportFunctions["default"].pathSeperator(cli.component);

        return new _TemplateGenerator["default"](new _ComponentTpl["default"](seperatePath.name, cli.postfix), cli, seperatePath.path);
      }
      /**
       * Generate React hook
       */


      if (cli.hook) {
        var _seperatePath = _SupportFunctions["default"].pathSeperator(cli.hook);

        return new _TemplateGenerator["default"](new _HookTpl["default"](_seperatePath.name, cli.postfix), cli, _seperatePath.path);
      }
      /**
       * Generate RTK store
       */


      if (cli.store) {
        var _seperatePath2 = _SupportFunctions["default"].pathSeperator(cli.store); //generate a slice also


        new _TemplateGenerator["default"](new _RTKSliceTpl["default"](_seperatePath2.name, cli.postfix), cli, _seperatePath2.path);
        return new _TemplateGenerator["default"](new _RTKStoreTpl["default"](_seperatePath2.name, cli.postfix), cli, _seperatePath2.path);
      }
      /**
       * Generate RTK slice
       */


      if (cli.slice) {
        var _seperatePath3 = _SupportFunctions["default"].pathSeperator(cli.slice);

        return new _TemplateGenerator["default"](new _RTKSliceTpl["default"](_seperatePath3.name, cli.postfix), cli, _seperatePath3.path);
      } // /**
      //  * Generate Vue 3 single file component
      //  */
      // if( cli.merged ) {
      //   let seperatePath = SupportFunctions.pathSeperator(cli.merged);
      //   return new TemplateGenerator(new SingleTpl(seperatePath.name, cli.folder, cli.postfix),cli,seperatePath.path);
      // }

    }
  }]);

  return TemplateFactory;
}();

var _default = TemplateFactory;
exports["default"] = _default;